procedure stage2;
{Finds the trajectory of NSTO payload.
 Steven S. Pietrobon 25 Dec 1997. Revised 29 Mar 1999, 6 Jan 2000}
var vo:double;
    ans:char;

begin{stage 2}
  write(question,'Transfer to apogee? ');
  readln(ans);
      f0 := 0.0;
      m1 := 0.0;
      Fd := 0.0;
      dF := 0.0;
      dRp := 0.0;
      dt := 1.0;
      Te := MPS_Ts;
      traj := air;
      fair := false;
      time_traj;
      writeln('Payload separation!');

  if (ans = 'y') or (ans = 'Y') then
    begin{to orbit}

      f0 := 0.0;
      Fd := 0.0;
      Ar := pi*sqr(PL_D)/4;
      m1 := 0.0;
      m0 := OMS_Mp;
      Me := PL_M;
      p0 := 0.0;
      dt := 1.0;
      dp := 0.0;
      dF := 0.0;
      dRp := 0.0;
      traj := air;
      fair := false;
      repeat
        trajectory;
      until h1 < 0;
      dt := -dt;
      trajectory;
      write('Perigee = ',(hp/1000):5:1,' km, ');
      write('Apogee = ',(ha/1000):5:1,' km, ');
      writeln('Average Altitude = ',(hp+ha)/2000:5:1,' km');

      write(question,'OMS2 Burn? ');
      readln(ans);
      if (ans = 'y') or (ans = 'Y') then
        begin{OMS2}
          writeln('OMS2 burn!');
          traj := vac;
          f0 := OMS_N*OMS_F;
          m1 := -f0/OMS_V;
          vo := sqrt(mu/(Re+h0));
          dt := 1.0;
          repeat
            trajectory
          until vi > vo;
          dt := -1.0;
          trajectory;
          dt := -((m0+Me)/(1/(exp((sqrt(mu/(Re+h0))-vi)/OMS_V)-1)+1))/m1;
          trajectory;
          if hp > 0
            then writeln('You have successfully reached low Earth orbit!')
            else writeln('Are you sure you know how to fly this thing?');
          write('Perigee = ',(hp/1000):5:1,' km, ');
          write('Apogee = ',(ha/1000):5:1,' km, ');
          writeln('Average Altitude = ',(hp+ha)/2000:5:1,' km');
          Te := -m0/m1;
          write('There is ',m0:5:1,' kg (',Te:5:2,' seconds) of ');
          writeln('propellant left.');
          write(question,'Continue? ');
          readln(continue);
        end;{OMS2}
    end;{to orbit}
end;{stage 2}
